#version 420 core

const int MAX_CLIP_PLANES = 6;

uniform vec3 plane[MAX_CLIP_PLANES];
uniform vec3 planeOrigin[MAX_CLIP_PLANES];

layout(location = 0) in vec3 position;
layout(location = 1) in vec4 color;
layout(location = 2) in vec4 color2;
layout(location = 3) in vec3 normal;
layout(location = 4) in vec2 texcoord;

layout(std140, binding = 0) uniform GlobalMatrices {
    mat4 vp;
    mat4 model;
    mat4 proj;
    mat4 view;
};

void clip()
{
    for (int i = 0; i < MAX_CLIP_PLANES; i++)
    {
        gl_ClipDistance[i] = dot(plane[i], position - planeOrigin[i]);
    }
}

void main() {
    clip();
    gl_Position = vp * model * vec4(position, 1.0);
}
