#version 420


layout(location = 0) in vec3 position;
layout(location = 1) in vec4 color;
layout(location = 2) in vec4 color2;
layout(location = 3) in vec3 normal;
layout(location = 4) in vec2 texcoord;

out vec2 texcoord_out;
out vec4 colorFromFile;

layout(std140, binding = 0) uniform GlobalMatrices { 
    mat4 vp;
	mat4 model;
    mat4 proj;
	mat4 view;
};

uniform float pointSize;

const int MAX_CLIP_PLANES = 6;

uniform vec3 plane[MAX_CLIP_PLANES];
uniform vec3 planeOrigin[MAX_CLIP_PLANES];

void clip()
{
    for (int i = 0; i < MAX_CLIP_PLANES; i++)
    {
        gl_ClipDistance[i] = dot(plane[i], position - planeOrigin[i]);
    }
}

void main() {
    texcoord_out = texcoord;
    colorFromFile = color;

    gl_PointSize = pointSize * 2;

    gl_Position = vp * model *  vec4(position, 1.0);

    clip();
}
