#version 420 core

const int MAX_CLIP_PLANES = 6;

layout(location = 0) in vec3 position;
layout(location = 1) in vec4 color1;
layout(location = 2) in vec4 color2;

layout(std140, binding = 0) uniform GlobalMatrices {
    mat4 vp;
    mat4 model;
    mat4 proj;
    mat4 view;
};

uniform vec3 plane[MAX_CLIP_PLANES];
uniform vec3 planeOrigin[MAX_CLIP_PLANES];

uniform float colorFactor1 = 0;
uniform float colorFactor2 = 1;

out vec4 io_color;

void clip()
{
    for (int i = 0; i < MAX_CLIP_PLANES; i++)
    {
        gl_ClipDistance[i] = dot(plane[i], position - planeOrigin[i]);
    }
}

void main() {
    io_color = color1 * colorFactor1 + color2 * colorFactor2;
    clip();
    gl_Position = vp * model * vec4(position, 1.0);
}
