#version 330

uniform sampler2D u_sampler;

in vec2 f_texCoords;

out vec4 f_color;

void main() {
    vec2 size = vec2(textureSize(u_sampler, 0));

    float d = 2*2;
    float m = 0;

    for (int y = -2; y <= 2; ++y)
    {
        for (int x = -2; x <= 2; ++x)
        {
            vec2 texCoords = vec2(x, y) / size + f_texCoords;
            vec4 color = texture(u_sampler, texCoords);

            if (color.r > 0)
            {
                d = min(d, abs(length(f_texCoords - texCoords)));
            }

            m += step(1, color.r);
        }
    }

    float maxDist = length(vec2(2) / size);
    vec4 color = vec4(0);

    if (m > 0)
    {
        color += vec4(0, d, maxDist, 1);

        if (d == 0)
        {
            color += vec4(1, 1, 0, 0);
        }
    }

    f_color = color;
}
